import edu.isi.integration.BSL.*; 
import edu.isi.integration.Phoebus.*;
import edu.isi.integration.Commons.*;

import com.wcohen.secondstring.*;

import java.util.*;
import java.sql.*;
import java.io.*;

public class Extraction {
    private static boolean inAgreement; //for keeping only the "in agreement" attributes. That is, you may have a few matching reference set records, and they share some attributes, but not all. In this case, only the shared attributes are kept around.

    public static void main(String args[]) {
	inAgreement = true;

	XMLReader xr = new XMLReader();
	DataSet set = new DataSet();
	DataSet refSet = new DataSet();
	String postSetFile = args[0];
	String postSetName = args[1];
	String refSetFile = args[2];
	String refSetName = args[3];
	loadDataSet(postSetFile, postSetName, set, xr);
	loadDataSet(refSetFile, refSetName, refSet, xr);
	processExtractions(set,refSet);
    }	

    public static HashMap processExtractions(DataSet set, DataSet refSet) {
	//first, we need to get the different ref set attributes
	Vector refAttrs = refSet.getAttributes();
	HashMap uniqAttrVals = new HashMap();
	String lastpid = "-1";
	String lastpost = "";
	String q = "";
	try {
	    set.openConnection();
	    Statement st = (set.getStatement());
	    Statement stmt = (set.getConnection()).createStatement();

	    //we only examine the ones that are the same, and we check them against what they should be...
	    q = "SELECT DISTINCT ";
	    q += "p."+set.getTableId()+" AS po, ";
	    for(int i = 0; i < refAttrs.size(); i++) {
		q += "r."+(String)refAttrs.get(i)+" AS "+(String)refAttrs.get(i)+",";
	    }	    
	    q += "p.post as post ";
	    q += " FROM ";
	    q += set.getTableName()+" p,"+refSet.getTableName()+" r, irMatches i WHERE ";
	    q += "p."+set.getTableId()+"=i."+set.getTableId()+" AND r."+refSet.getTableId()+"=i."+refSet.getTableId()+" AND i.rank <= 1  and score > 0 ORDER BY post";
	    //System.out.println(q);
	    ResultSet rs = st.executeQuery(q);	    
	    HashMap refSetVals = new HashMap();
	    
	    int group = 0;
	    while(rs.next()) {
		String pid = rs.getString("po");
		String post = rs.getString("post");
		if(!pid.equals(lastpid)) {
		    processExtracts(lastpid,lastpost,refSetVals,set,stmt);
		    lastpid = pid;
		    lastpost = post;
		    refSetVals.clear();
		    for(int z = 0; z < refAttrs.size(); z++) {
			String currAttr = (String)refAttrs.get(z);
			String attrVal = rs.getString(currAttr);
			Vector v = new Vector();
			v.add((String)attrVal);
			refSetVals.put((String)currAttr,(Vector)v);
		    }
		}
		else {
		    for(int z = 0; z < refAttrs.size(); z++) {
			String currAttr = (String)refAttrs.get(z);
			String attrVal = rs.getString(currAttr);

			Vector v = (Vector)refSetVals.get((String)currAttr);
			if(!v.contains((String)attrVal)) {
			    v.add((String)attrVal);
			}
			refSetVals.remove((String)currAttr);
			refSetVals.put((String)currAttr,(Vector)v);
		    }
		}

	    }
	    set.closeConnection();
	}
	catch(Exception e) {
	    System.out.println("ERROR IN: "+q);
	    e.printStackTrace();
	}
	return uniqAttrVals;
    }

    public static void processExtracts(String pid, String post, HashMap refSetVals, DataSet set, Statement st) {
	HashMap retVals = new HashMap();

	Iterator iter = refSetVals.keySet().iterator();
	int numAttrs = (refSetVals.keySet()).size();
	String postToks[] = post.split(" ");
	double postToksScores[] = new double[postToks.length];
	String postToksLabels[] = new String[postToks.length];
	for(int zz = 0; zz < postToks.length; zz++) {
	    postToksScores[zz] = 0.0;
	    postToksLabels[zz] = "JUNK";
	}
	while(iter.hasNext()) {
	    String attr =  (String)iter.next();
	    Vector attrVals = new Vector();

	    if(!inAgreement) {
		attrVals = (Vector)refSetVals.get((String)attr);
	    }
	    else {
		Vector notPrunedAttrVals = (Vector)refSetVals.get((String)attr);
		boolean hit = false;
		for(int aa = 0; aa < notPrunedAttrVals.size(); aa++) {
		    String currAttrV = (String)notPrunedAttrVals.get(aa);
		    if(attrVals.size() == 0) {
			attrVals.add(currAttrV);
		    }
		    else {
			if(!attrVals.contains(currAttrV)) {
			    attrVals.clear();
			    hit = true;
			    break;
			}
		    }
		}
	    }

	    String attrStr = "";
	    for(int j = 0; j < attrVals.size(); j++) {
		attrStr += (String)attrVals.get(j)+" ";
	    }
	    attrStr = attrStr.trim();
	    String refAttrToks[] = attrStr.split(" ");
	    for(int i = 0; i < postToks.length; i++) {
		if(refAttrToks.length == 0) {
		    break;
		}
		for(int x = 0; x < refAttrToks.length; x++) {
		    String currTok = postToks[i];
		    String currRefTok = refAttrToks[x];
		    JaroWinkler jw = new JaroWinkler();
		    double sc = getSimScore(currTok,currRefTok);
		    if((sc > postToksScores[i])) {
			postToksScores[i] = sc;
			postToksLabels[i] = attr;
		    }
		}
	    }
	}

	for(int y = 0; y < postToks.length; y++) {
	    String lab = postToksLabels[y];
	    if(!retVals.containsKey((String)lab)) {
		retVals.put((String)lab,(String)postToks[y]);
	    }
	    else {
		String s = (String)retVals.get((String)lab)+" "+postToks[y];
		retVals.remove((String)lab);
		retVals.put((String)lab,(String)s);
	    }
	}
	try {
	    Iterator iter2 = retVals.keySet().iterator();
	    String attrVals = "";
	    while(iter2.hasNext()) {
		String attr =  (String)iter2.next();

		if(!attr.equals("JUNK")) {
		    Vector refAttVals = new Vector();
		    if(!inAgreement) {
			refAttVals = (Vector)refSetVals.get((String)attr);
		    }
		    else {
			Vector notPrunedAttrVals = new Vector();
			notPrunedAttrVals = (Vector)refSetVals.get((String)attr);
			boolean hit = false;
			for(int aa = 0; aa < notPrunedAttrVals.size(); aa++) {
			    String currAttrV = (String)notPrunedAttrVals.get(aa);
			    if(refAttVals.size() == 0) {
				refAttVals.add(currAttrV);
			    }
			    else {
				if(!refAttVals.contains(currAttrV)) {
				    refAttVals.clear();
				    hit = true;
				    break;
				}
			    }
			}
		    }	    
		    
		    String refAttrStr = "";
		    for(int j = 0; j < refAttVals.size(); j++) {
			refAttrStr += (String)refAttVals.get(j)+" ";
		    }
		    refAttrStr = refAttrStr.trim();
		    attrVals = cleanField(refAttrStr,(String)retVals.get((String)attr));
		}

		if(!attr.equals("JUNK") && attrVals.trim().length() > 0) {
		    System.out.println(pid+"|"+attr+"|"+attrVals);
		}
	    }
	}
	catch(Exception e) {
	    e.printStackTrace();
	}
    }

    private static String cleanField(String ref, String post) {
	if(ref == null) {
	    //somehow we don't have a ref for it!
	    return post;
	}

	if(ref.trim().length() == 0) {
	    //some weird empty string
	    return post;
	}

	if(post.trim().length() == 0) {
	    //some weird all whitespace post!
	    return post.trim();
	}

	String brokenpost[] = post.split(" ");
	boolean removes[] = new boolean[brokenpost.length];
	for(int zz = 0; zz < removes.length; zz++) {
	    removes[zz] = false;
	}

	double baselineJW = getJWDice(ref, post);
	//System.out.println("START WITH: "+baselineJW);
	if(baselineJW == 0.0) {
	    return "";
	}
	String savedToks = "";
	String temp = "";
	int removeIndex = -1;
	for(int i = 0; i < brokenpost.length; i++) {
	    for(int j = 0; j < brokenpost.length; j++) {
		if(i != j) {
		    temp += brokenpost[j]+" ";
		}
	    }
	    temp = temp.trim();  
	    if(temp.trim().length() > 0) {
		double scoreJW = getJWDice(ref,temp);
		//System.out.println("TRYING: "+temp+" SC: "+scoreJW);
		if( (scoreJW > baselineJW)) {
		    baselineJW = scoreJW;
		    removes[i] = true;
		    removeIndex = i;
		}	    
	    }
	    temp = "";
	}

	for(int z = 0; z < brokenpost.length;z++) {
	    if(!removes[z]) {
		savedToks += brokenpost[z]+" ";
	    }
	}
	savedToks = savedToks.trim();
	if(removeIndex != -1) {
	    savedToks = cleanField(ref, savedToks);
	    savedToks = savedToks.trim();
	}
	/*
	  if(!post.equals(savedToks)) {
	  System.out.println("START WITH: "+post);
	  System.out.println("COMPARE TO: "+ref);
	  System.out.println("END WITH: "+savedToks);
	  }
	*/
	return savedToks;
    }

    public static void loadDataSet(String file, String setName, DataSet ds, XMLReader xr) {
	xr.retrieveDataSet(file, setName, ds);
    }

    public static double getJWDice(String refStr, String postStr) {
	refStr = refStr.toLowerCase();
	postStr = postStr.toLowerCase();
	String refToks[] = refStr.split(" ");
	String postToks[] = postStr.split(" ");
	int intersection = 0;
	TreeSet usedPostToks = new TreeSet();
	JaroWinkler jw = new JaroWinkler();
	//SmithWaterman jw = new SmithWaterman();
	for(int r = 0; r < refToks.length; r++) {
	    for(int t = 0; t < postToks.length; t++) {
		double sc = jw.score(jw.prepare(refToks[r].toLowerCase()), jw.prepare(postToks[t].toLowerCase()));
		//double sc = jw.getSimilarity(refToks[r],postToks[t]);
		String ti = (String)(new Integer(t)).toString();
		if(sc >= 0.95 && !usedPostToks.contains((String)ti)) {
		    //System.out.println("TOK MATCH: "+refToks[r]+" VS "+postToks[t]);
		    intersection++;
		    //usedPostToks.add((String)ti);
		}
	    }
	}	    
	    //Dices coefficient = (2*Common Terms) / (Number of terms in String1 + Number of terms in String2)
	double sc = ((2.0*(double)intersection) / (double)((double)refToks.length + (double)postToks.length));
	//System.out.println(refStr+" VS "+postStr+" EQ "+sc);
	return sc;
    }

    public static double getSimScore(String currTok, String currRefTok) {
	currTok = currTok.toLowerCase();
	currRefTok = currRefTok.toLowerCase();
	JaroWinkler jw = new JaroWinkler();
	//double jwSc = jw.getSimilarity(jw.prepare(currTok),jw.prepare(currRefTok));
	double jwSc = jw.score(jw.prepare(currRefTok.toLowerCase()), jw.prepare(currTok.toLowerCase()));	
	return jwSc;
    }
}