import edu.isi.integration.BSL.*; 
import edu.isi.integration.Phoebus.*;
import edu.isi.integration.Commons.*;

import java.io.*;
import java.sql.*;
import java.util.*;
public class ExtractionResults {
    public static void main(String args[]) {
	XMLReader xr = new XMLReader();
	DataSet set = new DataSet();
	DataSet refSet = new DataSet();
	String postSetFile = args[0];
	String postSetName = args[1];
	String allPostsTable = args[2];
	String extFile = args[3];
	loadDataSet(postSetFile, postSetName, set, xr);
	System.out.println("-------------");
	System.out.println("FIELD LEVEL RESULTS");
	extractionResultsField(set,allPostsTable,extFile,false);
    }

    public static void extractionResultsField(DataSet posts, String allPostsTable, String extractionFile, boolean inAgreement) {
	HashMap corrs = new HashMap();
	HashMap mades = new HashMap();
	HashMap posses = new HashMap();
	HashMap seenPidsCorrs = new HashMap();
	HashMap seenPidsMades = new HashMap();
	try {
	    BufferedReader in = new BufferedReader(new FileReader(extractionFile));
	    String s = "";
	    posts.openConnection();
	    int lineNum = 0;
	    while((s = in.readLine()) != null) {
		lineNum++;
		String line = s;
		//System.out.println(line);
		String toks[] = line.split("\\|");
		String pid = toks[0];
		String attr = toks[1];
		String extVal = toks[2];
		

		//mades
		//if(posts.getTableName().toLowerCase().equals("craigslistposts") ||
		if(posts.getName().toLowerCase().equals("craigslistposts")) {
		    if(!isRecordWithExtraction(pid,allPostsTable,posts)) {
			//System.out.println("IGNORE...");
			continue;
		    }
		}

		boolean hitM = false;
		if(!seenPidsMades.containsKey((String)attr)) {
		    Vector vp = new Vector();
		    vp.add((String)pid);
		    seenPidsMades.put((String)attr, (Vector)vp);
		}
		else {
		    Vector vp = (Vector)seenPidsMades.get((String)attr);
		    if(!vp.contains((String)pid)) {
			vp.add((String)pid);			    
		    }
		    else {
			hitM = true;
		    }
		}

		if(!hitM) {
		    if(!mades.containsKey((String)attr)) {
			mades.put((String)attr,new Integer(1));
		    }
		    else {
			Integer i = (Integer)mades.get((String)attr);
			i++;
			mades.remove((String)attr);
			mades.put((String)attr,(Integer)i);
		    }
		}

		//corrs...
		String q = "SELECT "+attr+" FROM "+allPostsTable+" WHERE "+posts.getTableId()+"='"+pid+"'";
		String corrExt = "";
		ResultSet rs = (posts.getStatement()).executeQuery(q);		
		while(rs.next()) {
		    corrExt = rs.getString(attr);
		}	
		if(corrExt != null && corrExt.trim().length() > 0 && extVal.trim().length() > 0) {
		    boolean hit = false;
		    if(!seenPidsCorrs.containsKey((String)attr)) {
			Vector vp = new Vector();
			vp.add((String)pid);
			seenPidsCorrs.put((String)attr, (Vector)vp);
		    }
		    else {
			Vector vp = (Vector)seenPidsCorrs.get((String)attr);
			if(!vp.contains((String)pid)) {
			    vp.add((String)pid);			    
			}
			else {
			    hit = true;
			}
		    }

		    if(fieldMatch(corrExt,extVal) && !hit) {
			if(!corrs.containsKey((String)attr)) {
			    corrs.put((String)attr,new Integer(1));
			}
			else {
			    Integer i = (Integer)corrs.get((String)attr);
			    i++;
			    corrs.remove((String)attr);
			    corrs.put((String)attr,(Integer)i);
			}
		    }
		    else {
			if(!hit) {
			    /*
			    System.out.println("SHOULD BE: "+corrExt);
			    System.out.println("WE GOT: "+extVal);
			    System.out.println("ON LINE: "+lineNum);
			    System.out.println();
			    */
			}
		    }
		}
	    }   

	    //calculate and get poss
	 	posses.clear();
		Iterator iterator = mades.keySet().iterator();
		while (iterator.hasNext()) {
		    String attr = (String)iterator.next();
		    int poss = 0;
		    String q2 = "SELECT "+attr+" FROM "+allPostsTable;
		    System.err.println(q2);
		    ResultSet rs2 = (posts.getStatement()).executeQuery(q2);
		    while(rs2.next()) {
			String s2 = rs2.getString(attr);
			if(s2 != null && s2.trim().length() > 0) {
			    poss++;
			}
		    }
		    posses.put((String)attr,new Integer(poss));
		}

	    posts.closeConnection();

	    Iterator attrIt = mades.keySet().iterator();
	    while(attrIt.hasNext()) {
		String attr = (String)attrIt.next();
		if( mades.get((String)attr) != null &&
		    corrs.get((String)attr) != null &&
		    posses.get((String)attr) != null) {
		    int made = ((Integer)mades.get((String)attr)).intValue();
		    int corr = ((Integer)corrs.get((String)attr)).intValue();
		    int poss = ((Integer)posses.get((String)attr)).intValue();
		    System.err.println(attr+" "+poss);
		    double recall = (double)corr / (double)poss;
		    double prec = (double)corr / (double)made;
		    double f = (2.0*prec*recall) / (prec + recall);
		    System.out.println("ATTR:\t"+attr+"\tR:\t"+recall+"\tP:\t"+prec+"\tF:\t"+f);
		}
	    }
	}
	catch(Exception e) {
	    e.printStackTrace();
	}
    }

    public static boolean isRecordWithExtraction(String pid, String postsWithExtsTable, DataSet posts) {
	int cnt = 0;	    
	try {
	    String q = "SELECT * FROM "+postsWithExtsTable+" WHERE "+posts.getTableId()+"='"+pid+"'";
	    ResultSet rs = (posts.getStatement()).executeQuery(q);
	    while(rs.next()) {
		cnt++;
	    }
	}
	catch(Exception e) {
	    e.printStackTrace();
	}
	if(cnt > 0) {
	    return true;
	}
	return false;
    }

    public static boolean fieldMatch(String sTruth, String sMade) {
	//System.out.println("SHOULD BE: "+sTruth);
	//System.out.println("WE GOT: "+sMade);
	if(sTruth.trim().length() == 0 || sMade.trim().length() == 0) {
	    return false;
	}
	if(sTruth == null || sMade == null) {
	    return false;
	}
	sTruth = sTruth.replaceAll("\\s+"," ");
	String toksTruth[] = sTruth.split(" ");	    
	sMade = sMade.replaceAll("\\s+"," ");
	String toksMade[] = sMade.split(" ");
	if(toksTruth.length == toksMade.length) {
	    for(int x = 0; x < toksTruth.length; x++) {
		for(int y = 0; y < toksMade.length; y++) {
		    if(toksTruth[x].trim().length() > 0 && toksMade[y].trim().length() > 0 && 
		       toksTruth[x].equals(toksMade[y])) {
			toksTruth[x] = "<<FOUND>>";
			toksMade[y] = "<<FOUND>>";
		    }
		}
	    }
	    int found = 0;
	    for(int zz = 0; zz < toksTruth.length; zz++) {
		if(!(toksTruth[zz].equals("<<FOUND>>") ||
		     toksMade[zz].equals("<<FOUND>>"))) {
		    found = 1;
		}
	    }
	    if(found == 0) {
		return true;
	    }
	}
	return false;
    }

    public static void loadDataSet(String file, String setName, DataSet ds, XMLReader xr) {
	xr.retrieveDataSet(file, setName, ds);
    }
}