import java.util.*;
import java.io.*;

public class Averager {
    public static void main(String args[]) {
	/*
NUM CANDS:	27530
RR:	0.7349928766701321
PC:	1.0
	*/
	System.out.println("BLOCKING");
	System.out.println("+++++++++++++++");
	System.out.println("NUM CANDS AVG:\t" +getAvgScore("NUM CANDS:",args[0]));
	System.out.println();
	System.out.println("RR AVG:\t"+getAvgScore("RR:",args[0]));
	System.out.println();
	System.out.println("PC AVG:\t"+getAvgScore("PC:",args[0]));
	System.out.println();
	System.out.println("________________");
	System.out.println("RECORD LINKAGE");
	System.out.println("++++++++++++++");
	System.out.println("REC AVG:\t"+getAvgScore("RLREC:",args[0]));
	System.out.println();
	System.out.println("PRECI AVG:\t"+getAvgScore("RLPRECISION:",args[0]));
	System.out.println();
	System.out.println("F-MES AVG:\t"+getAvgFMes("RLREC:","RLPRECISION:",args[0]));
	System.out.println();
	System.out.println("________________");
	String attrs[] = args[1].split(",");
	System.out.println("EXTRACTION");
	System.out.println("++++++++++++++");
	for(int i = 0; i < attrs.length; i++) {
	    System.out.println(attrs[i]+" TOKEN RECALL AVG:\t"+getAvgScore("TOKEN_ATTR_"+attrs[i]+"_RECALL:",args[0]));
	    System.out.println();
	    System.out.println(attrs[i]+" TOKEN PRECISION AVG:\t"+getAvgScore("TOKEN_ATTR_"+attrs[i]+"_PRECISION:",args[0]));
	    System.out.println();
	    System.out.println(attrs[i]+" TOKEN F-MES AVG:\t"+getAvgFMes("TOKEN_ATTR_"+attrs[i]+"_RECALL:"
	    							,"TOKEN_ATTR_"+attrs[i]+"_PRECISION:",args[0]));
	    System.out.println();
	    System.out.println("%%%%");
	    System.out.println(attrs[i]+" FIELD RECALL AVG:\t"+getAvgScore("FIELD_ATTR_"+attrs[i]+"_RECALL:",args[0]));
	    System.out.println();
	    System.out.println(attrs[i]+" FIELD PRECISION AVG:\t"+getAvgScore("FIELD_ATTR_"+attrs[i]+"_PRECISION:",args[0]));
	    System.out.println();
	    System.out.println(attrs[i]+" FIELD F-MES AVG:\t"+getAvgFMes("FIELD_ATTR_"+attrs[i]+"_RECALL:"
	    							,"FIELD_ATTR_"+attrs[i]+"_PRECISION:",args[0]));
	    System.out.println();
	    System.out.println("----");
	}
    }
    
    public static String getAvgFMes(String recMarker, String precMarker, String file) {
	System.out.println("FMEASURE BETWEEN "+recMarker+" _AND_ "+precMarker);
	double recScore = 0.0;
	double precScore = 0.0;
	double fTot = 0.0;
	try {
	    BufferedReader in = new BufferedReader(new FileReader(file));
	    String str = ""; 
	    while ((str = in.readLine()) != null) {
		if(str.indexOf(recMarker) == 0) {
		    String toks[] = str.split(recMarker);
		    recScore = (double)(new Double(toks[1])).doubleValue();
		}
		if(str.indexOf(precMarker) == 0) {
		    String toks[] = str.split(precMarker);
		    precScore = (double)(new Double(toks[1])).doubleValue();
		    double fme =  ((2*recScore*precScore)/(recScore + precScore));
		    System.out.println(fme);
		    fTot += fme;
		    //		    fTot += ((2*recScore*precScore)/(recScore + precScore));
		}
	    } //while
	} //try
	catch(Exception e) { e.printStackTrace();}
	double avg = fTot / 10.0;
	return (new Double(avg)).toString();
    }

    public static String getAvgScore(String scoreMarker, String file) {
	System.out.println(scoreMarker);
	double scoreTot = 0.0;
	try {
	    BufferedReader in = new BufferedReader(new FileReader(file));
	    String str = ""; 
	    while ((str = in.readLine()) != null) {
		if(str.indexOf(scoreMarker) == 0) {
		    //System.out.println("FOUND: "+str);
		    String toks[] = str.split(scoreMarker);
		    System.out.println(toks[1]);
		    scoreTot += (double)(new Double(toks[1])).doubleValue();
		    //System.out.println(toks[1]);
		}
	    } //while
	} //try
	catch(Exception e) { e.printStackTrace();}
	return (new Double((double)scoreTot/10.0)).toString();
    }
}