import java.io.*;
import java.util.*;

public class BuildFolds {
    private static Vector trainData;
    private static Vector testData;
    private static Vector allData;

    public static void main(String args[]) {
	String per = args[0];
	String domain = args[1];
	String fullDataFile = args[2];

	double percent = (new Double(per)).doubleValue();

	for(int x = 1; x <= 10; x++) {
	    allData = getAllData(fullDataFile);

	    int numTrain = (int)(allData.size()*percent);
	    int numTest = allData.size() - numTrain;

	    int history[] = new int[numTrain+numTest]; //for keeping the history of the numbers
	    //initialize it all to 0's first
	    for(int i = 0; i < history.length; i++) {
		history[i] = 0;
	    }

	    Random rand = new Random();
	    trainData = new Vector();
	    testData = new Vector();
	    
	    //now, generate the random numbers	
	    for(int i = 0; i < allData.size(); i++) {
		int n = rand.nextInt(numTrain+numTest);
		while(history[n] == 1) {
		    n = rand.nextInt(numTrain+numTest);
		}
		history[n] = 1;
		String dd  = (String)allData.get(n);
		
		if(i <= numTrain) {
		    trainData.add((String)dd);
		}
		else {
		    testData.add((String)dd);
		}
	    }
	    
	    System.out.println("ALL DATA: "+allData.size());
	    
	    writeFile("trainFold_"+domain+x+".txt",trainData);
	    System.out.println("TRAIN DATA: "+trainData.size());
	    
	    writeFile("testFold_"+domain+x+".txt",testData);
	    System.out.println("TEST DATA: "+testData.size());
	}
    }

    public static Vector getAllData(String file) {
	Vector v = new Vector();
	try {
	    BufferedReader in = new BufferedReader(new FileReader(file));
	    String str = "";
	    String holder = "";
	    while ((str = in.readLine()) != null) {
		str = str.trim();
		v.add((String)str);
	    } //while
	} //try
	catch(Exception e) { e.printStackTrace();}
	return v;
    }

    public static void writeFile(String filename, Vector data) {
	try {
	    BufferedWriter outFold1 = new BufferedWriter(new FileWriter(filename));
	    for(int i = 0; i < data.size(); i++) {
		String d = (String)data.get(i);
		outFold1.write(d);
		outFold1.newLine();
	    }
	    outFold1.close();
	}
	catch(Exception e) {e.printStackTrace();}
    }

}