java -classpath "WebPhoebus.jar;." edu.isi.integration.BSL.BSL setUpRefIndex configFiles/bft/Hotels.xml Hotels configFiles/bft/PostsTrain.xml postsTrain configFiles/bft/PostsAttrMethod.xml

#Parameter 1: program to run (setUpRefIndex)
#Parameter 2: Path to the XML file that defines the reference set table name
#Parameter 3: The name of the dataset defined in the refernece set XML file
#Parameter 4: path to the XML file for the training posts table
#Parameter 5: name of the data set defined in XML file of parameter 4
#Parameter 6: List of attributes and methods from which to learn blocking scheme (sets up a table for each combination and indexes it)
 
#You would do this for a bunch of trials
for i in 1 2 3 4 5 6 7 8 9 10
do
 java -classpath "WebPhoebus.jar;secondstring.jar;commons-codec.jar;." Experiment run bftFolds\\trainFold_bft$i.txt configFiles\\bft\\PostsTrain.xml postsTrain fullLabeledPosts configFiles\\bft\\Hotels.xml hotels configFiles\\bft\\PostsAttrMethod.xml configFiles\\bft\\CommonAttributes.xml "price,bookDate" bftFolds\\testFold_bft$i.txt configFiles\\bft\\PostsTest.xml postsTest trueMatches BFT_OUTPUT.txt true >> ALL_OUTPUT_BFT.txt
done

#Parameter 1: value is "run" which means run the experiments
#Param 2: list of ids to load into training. In this example, we put them in a bftFolds directory
#Param 3: path to XML file that defines training posts table (labeled extractions are put in here)
#Param 4: name of training posts source
#Param 5: name of table that holds full labeled training data (remember, postsTrain is just a subset since it's a training fold)
#Param 6: path to XML file that defines reference set
#Param 7: name of reference set source
#Param 8: path to XML file that defines attributes/methods to use for learning blocking rule
#Param 9: path to XML file that defines the features for extracting common attributes (i.e. not in reference set)
#Param 10: names of the common attributes
#Param 11: list of ids to load into the testing table
#Param 12: path to XML file that defines testing posts table (extracted attributes put here)
#Param 13: name of the testing posts source
#Param 14: table that defines the true matches between the sources
#Param 15: file that holds the output results
#Param 16: set to true if matching between posts and reference set is 1-1, set to false if 1-M